=== debian/changelog ===
rock-master-19.06-tools-graph-analysis (0.20190329-1~bionic) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: github:/rock-core/tools-graph_analysis.git
  * branch: refs/heads/master
  * commit: 99801277e7899b353829c42fa293795281f24878
  * tag: 

 -- Packaging Daemon <rock-dev@dfki.de>  Fri, 05 Jul 2019 12:21:40 +0200
