=== debian/control ===
Source: rock-master-19.06-tools-graph-analysis
Section: science
Priority: extra
Maintainer: Rock Packaging Daemon <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, build-essential, cmake, coinor-cbc, coinor-clp, coinor-libcbc-dev, coinor-libclp-dev, coinor-libcoinutils-dev, coinor-libosi-dev, glpk-utils, graphviz, graphviz-dev, libboost-dev, libboost-filesystem-dev, libboost-graph-dev, libboost-iostreams-dev, libboost-program-options-dev, libboost-regex-dev, libboost-system-dev, libboost-thread-dev, libglpk-dev, libqt4-dev, libxml2-utils, libyaml-cpp-dev, qt4-qmake, rock-master-19.06-base-cmake, rock-master-19.06-base-numeric, rock-master-19.06-base-types, rock-master-19.06-external-gexf, rock-master-19.06-external-lemon, rock-master-19.06-external-snap, rock-master-19.06-utilmm
Standards-Version: 3.9.2
Homepage: http://rock-robotics.org
#Vcs-Git: git://git.debian.org/collab-maint/bla.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/bla.git;a=summary

Package: rock-master-19.06-tools-graph-analysis
Architecture: any
Depends: ${shlibs:Depends}, rock-master-19.06-base-cmake, rock-master-19.06-base-numeric, rock-master-19.06-base-types, rock-master-19.06-external-gexf, rock-master-19.06-external-lemon, rock-master-19.06-external-snap, rock-master-19.06-utilmm, cmake, build-essential, libboost-dev, libboost-graph-dev, libboost-program-options-dev, libboost-regex-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-iostreams-dev, libboost-system-dev, graphviz, graphviz-dev, libqt4-dev, qt4-qmake, libyaml-cpp-dev, glpk-utils, libglpk-dev, coinor-libcoinutils-dev, coinor-libosi-dev, coinor-clp, coinor-libclp-dev, coinor-cbc, coinor-libcbc-dev, libxml2-utils
Description: A graph library (frontend) for modeling and analysis
 This library allows wrapping and extension of existing graph libraries for modeling and analysis.
  It provides a unified interface for boost_graph, LEMON and SNAP and comes with a graphical interface to
  create graph based GUIs.
  Additionally it contains algorithms for multi-commodity min-cost flow optimization.
